/*
                                 Visual FX
                                    For
                                 Image FX
                               SetUp Script
                           Written By J.L. White

                         (C)1997 Merlin's Software

*/

parse arg Num Frames
options results
address "IMAGEFX.1"
ReDraw On
Quotes = '22'X

	RequestResponse "Do You Need Instructions?"
	if rc = 0 then do
		call Docs()
		end	

if exists("libs:flyer.library") then do
	if (POS('PROJECT_REXX_PORT',SHOW('Ports')) =0) then do
		RequestNotify 'Flyer Must Be Running First!'
		exit
		end
	call OpenFlyStuff()


	Gadget.1 = 'D/110/22/120/ImageA Type/4/FLYER CLIP/FLYER STILL/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1
   		end

	call GetA()
end
else do
	Gadget.1 = 'D/110/22/120/ImageA Type/2/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1+2
   		end

	call GetA()
end
if FlyOn = 1 then
	call CloseStuff()

	ColorA = 0
	ColorB = 1
	Border = -1

	Gadget.1 = ' Select Border Options! '
	Gadget.2 = 'Use Checkerboard Boxes'
	Gadget.3 = 'Use Beveled Edges'
	Gadget.4 = 'Use Normal Edges'
	ListRequest 4 Gadget
	BorderType = 0
	if result = 2 then BorderType = 0
	if result = 3 then BorderType = 1
	if result = 4 then BorderType = 2

	if BorderType = 0 then do
		ActiveColor 0
		RequestNotify "Click On Color To Use For 1st Color Then Click "Quotes"Okay"Quotes""
		ActiveColor
		ColorA = result
		ActiveColor 1
		RequestNotify "Click On Color To Use For 2nd Color Then Click "Quotes"Okay"Quotes""
		ActiveColor
		ColorB = result
		ActiveColor 1

		end

	if BorderType = 1 then do
		NumA = 1
		NumB = 100
		NumC = 30
		RequestSlider '"Enter Thickness Of Bevel!"' NumA NumB NumC
		Border = Result
		end
	CropAnswer = "None"
	RequestResponse "Does Image Need To Be Cropped?"
	if rc = 0 then do
		i = Start
		call LoadA()
		call CropPic()
		end	

call open TempFile,"VFXIFX:TempDrawer/"strip(Num),W
call writeln TempFile,PicAName
call writeln TempFile,Start
call writeln TempFile,End
call writeln TempFile,IAType
call writeln TempFile,ColorA
call writeln TempFile,ColorB
call writeln TempFile,Border
call writeln TempFile,BorderType
call writeln TempFile,CropAnswer
call close TempFile
exit




CropPic:
	Learn "RAM:VFX" NoHeader Quiet Force
	Crop
	Learn Stop Quiet Force

	call open TempFile,"RAM:VFX.ifx",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line StartLine" "RestOfLine
		if StartLine = "Crop" then CropAnswer = line
		end
	call close TempFile
	address command "Delete >NIL: Ram:VFX.ifx"

return

GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetA:
 if IAType = 0 then do
	call Switcher(TOSW)
	PicAName = GetFile("Select Flyer Clip For ImageA!  ",DriveName)
	Name = GetFileName(PicAName)
	if Name = "" then do
		Address FLY_1 OK_TEXT " OK "
		Title = "You Must Enter A Valid Clip Name To Use!"
		Address FLY_1 FYINT Title
		Address FLY_1 Quit
		call Switcher(TOWB)
		exit
		end
	Address FLY_1 SetFileName PicAName
	Address FLY_1 GetClipLength PicAName
	End = result
	Start = 0
	Address FLY_1 Program "5"
	Address FLY_1 StartNum Start
	Address FLY_1 EndNum End
	Address FLY_1 CurrentNum "0"
	Address FLY_1 GetTimeNT "Select A Range Of Frames To Process!"
	Start = word(result,1)*2
	End = word(result,2)*2
	Start  = Start + 1
	End = End +2
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	call Switcher(TOWB)
	address command "C:Wait 1"
	ScreenToFront
	end
   if IAType = 1 then do
	RequestFile '"Select Flyer Still For ImageA!"' DriveName ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 2 then do
	RequestFile '"Select FileName For ImageA!"' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 3 then do
	RequestFile '"Select BaseName For ImageA! "' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
return


OpenFlyStuff:
	FlyOn = 1
	address command "run VFXIFX:FLY" 
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	DriveName = FindDrive()
return


FindDrive:
	address command "C:Info >RAM:DriveList"
	call open TempFile,"RAM:DriveList",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			FlyVolume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:DriveList"
return FlyVolume



LoadA:
	if IAType = 0 then do
		LoadBuffer PicAName Force i
		end
	if IAType = 1 then do
		LoadBuffer PicAName Force 1
		end
	if IAType = 2 then do
		LoadBuffer PicAName Force
		end
	if IAType = 3 then do
		LoadBuffer PicAName""right(i,3,'0') Force
		end
return


Docs:

	text1 = '"This effect takes an image, scales it and places it in"'
	text2 = '"the center of the screen then surrounds that image with"'
	text3 = '"small copies of itself. You have various options to place"'
	text4 = '"borders or image process the smaller images."'
	text5 = '" "'
	text6 = '"The Crop Image option is there for Flyer Users. The clip"'
	text7 = '"may have garbage on the edges, that are not seen because"'
	text8 = '"of overscan but when scaled to the center, you can see it."'
	text9 = '"This allows you to crop the garbage first, then it will"'
	text10 = '"scale it back to the correct size."'

	Gadget.1  = 'TEXT LE=10 TE=4 LB='text1' '
	Gadget.2  = 'TEXT LE=10 TE=14 LB='text2' '
	Gadget.3  = 'TEXT LE=10 TE=24 LB='text3' '
	Gadget.4  = 'TEXT LE=10 TE=34 LB='text4' '
	Gadget.5  = 'TEXT LE=10 TE=44 LB='text5' '
	Gadget.6  = 'TEXT LE=10 TE=54 LB='text6' '
	Gadget.7  = 'TEXT LE=10 TE=64 LB='text7' '
	Gadget.8  = 'TEXT LE=10 TE=74 LB='text8' '
	Gadget.9  = 'TEXT LE=10 TE=84 LB='text9' '
	Gadget.10  = 'TEXT LE=10 TE=94 LB='text10' '
	Gadget.11 = 'END'
	NewComplexRequest  '"Instructions For Effect #04"' Gadget 420 106

return



