/*
                                 Visual FX
                                    For
                                 Image FX
                               SetUp Script
                           Written By J.L. White

                         (C)1997 Merlin's Software

*/
parse arg Num Frames
options results
address "IMAGEFX.1"
Quotes = '22'X
	RequestResponse "Do You Need Instructions?"
	if rc = 0 then do
		call Docs()
		end	
	ReDraw On
	Gadget.1 = ' Select Background Type! '
	Gadget.2 = ' Use Seamless Image '
	Gadget.3 = ' Use Texture & Color '
	ListRequest 3 Gadget
	BackType = 0
	if result = 2 then BackType = 0
	if result = 3 then BackType = 1


	if BackType = 0 then do
		LoadBuffer "VFXIFX:Images/Pics/Seamless.Pic" Force
		RequestNotify "Look At Examples For FileName Then Click 
		RequestFile '"Select File To Use For Background!" "VFXIFX:Images/Seamless" ""'
		BrushName = result
		Color = 1
		end

	if BackType = 1 then do
		LoadBuffer "VFXIFX:Images/Pics/Textures.Pic" Force
		RequestNotify "Look At Examples For FileName Then Click "Quotes"Okay"Quotes""
		RequestFile '"Select File To Use For Background!" "VFXIFX:Images/Textures" ""'
		BrushName = result
		ActiveColor 2
		RequestNotify "Click On Color To Use For Highlights Then Click "Quotes"Okay"Quotes""
		ActiveColor
		Color = result
		ActiveColor 1
		end



	Height = 480
	Width = 640
	if exists("libs:flyer.library") then do
		Height = 480
		Width = 752
		end
	
	text1 = '"Move X"'
	text2 = '"Move Y"'
	Gadget.1  = 'SLIDER LE=70 TE=4 WD=150 HT=14 LB='text1' IN=1 LO=-10 HI=10 LV=%-3ld'
	Gadget.2  = 'SLIDER LE=70 TE=22 WD=150 HT=14 LB='text2' IN=1 LO=-10 HI=10 LV=%-3ld'
	Gadget.3 = 'INTEGER 60  40 50 14 "Width:"' Width
	Gadget.4 = 'INTEGER 200  40 50 14 "Height:"' Height
	Gadget.5 = 'END'
	NewComplexRequest  '"Select X & Y Movements & Screen Size!"' Gadget 270 60
	if rc ~= 0 then do
		XOff = 0
		YOff = 0
		end
	else do
		XOff = RESULT.1
		YOff = RESULT.2
		Width = RESULT.3
		Height = RESULT.4
		end
RequestNumber '"Enter Number Of Frames To Process!"' Frames
End = result

call open TempFile,"VFXIFX:TempDrawer/"strip(Num),W
call writeln TempFile,BrushName
call writeln TempFile,Color
call writeln TempFile,BackType
call writeln TempFile,Width
call writeln TempFile,Height
call writeln TempFile,XOff
call writeln TempFile,YOff
call writeln TempFile,End
call close TempFile
exit



Docs:

	text1 = '"This effect takes a seamless image and scrolls it on"'
	text2 = '"the X & Y axis (larger = faster). We supply some but"'
	text3 = '"use any image that you wish as long as it is seamless."'
	text4 = '"The program will fill the screen and move it in the"'
	text5 = '"selected direction for you. Just tell it how long you"'
	text6 = '"want it to scroll (how many frames). This is perfect"'
	text7 = '"for use with CG and scroll pages."'

	Gadget.1  = 'TEXT LE=10 TE=4 LB='text1' '
	Gadget.2  = 'TEXT LE=10 TE=14 LB='text2' '
	Gadget.3  = 'TEXT LE=10 TE=24 LB='text3' '
	Gadget.4  = 'TEXT LE=10 TE=34 LB='text4' '
	Gadget.5  = 'TEXT LE=10 TE=44 LB='text5' '
	Gadget.6  = 'TEXT LE=10 TE=54 LB='text6' '
	Gadget.7  = 'TEXT LE=10 TE=64 LB='text7' '
	Gadget.8 = 'END'
	NewComplexRequest  '"Instructions For Effect #01"' Gadget 400 76

return
